' DJ Telnet script for Homeseer, based on code by Bart
' NOTE: In *very* early stages, undocumented, far from being user friendly
' ISSUE: only sending 1 character when connecting to Cisco networking devices.
' HOW TO START: fill out the strUsername,strPassword,RemoteIP and PortNumber below
	
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
   
Sub Main(parms As Object)
    Telnet
end sub
 
Sub Telnet()
	Const varVersion as String = "DJ_Telnet_0.5"
	Const strUsername as String = "username"
	Const strPassword as String = "password"
    Const RemoteIP As String = "192.168.1.1"
    Const PortNumber As Integer = 23

    dim Reply as string
    dim messages as string
    dim strpos
    dim old_messages, new_messages as string
    dim old_messages_num, new_messages_num
    dim length, strpos1, strpos2
    

    ' --- Connect 
    Dim Client As New TcpClient()
    Client.Connect(IPAddress.Parse(RemoteIP), PortNumber)
    Dim NetStream As NetworkStream = Client.GetStream()
    ' --- Get first device response after connecting
    Reply = ReadString(Client)
    hs.WriteLog(varVersion, "Connected:" & Reply)
    hs.WaitSecs(2)
	
    ' --- It should ask for a username, so SEND username
    SendString(NetStream, strUsername & vbCrLf)
    hs.WaitSecs(2)
    Reply = ReadString(Client)
    hs.WriteLog(varVersion, "After username:" & Reply)
    
	' --- It should now ask for a password, so SEND password
    SendString(NetStream, strPassword & vbCrLf)
    hs.WaitSecs(2)

    ' --- Show what it displays after sending the password
    Reply = ReadString(Client)
    hs.WriteLog(varVersion, "After password:" & Reply)
	hs.WaitSecs(2)

	' --- Here you can add more commands and possibly store some of the responses in HS devices.

    ' --- Logout & Disconnect
    hs.WriteLog(varVersion, "Going to DISCONNECT!")

    SendString(NetStream, "exit" & vbCrLf & vbCrLf)
    SendString(NetStream, vbCrLf)
    
    ' --- Close connection
    Client.Close()

End Sub

' --- Function to process received data 
Private Function ReadString(ByVal Client As System.Net.Sockets.TcpClient) As String
    Dim Stream As NetworkStream = Client.GetStream
    Dim Buffersize As Integer = Client.ReceiveBufferSize
    Dim Data(Buffersize -1) As Byte
    If Stream.CanTimeout Then
        Stream.ReadTimeout = 1000 * 15
    End If
    Dim BytesRead As Integer = Stream.Read(Data, 0, Buffersize)
    Return Encoding.ASCII.GetString(Data, 0, BytesRead)
End Function
 
' --- Function to process send data
Private Function SendString(ByVal Stream As NetworkStream, ByVal Data As String) As Boolean
    Dim Bytes As [Byte]() = Encoding.ASCII.GetBytes(Data)
    If Stream.CanTimeout Then
        Stream.WriteTimeout = 1000 * 5
    End If
    Stream.Write(Bytes, 0, Bytes.Length)
    Return True
End Function

